<?php

class User {
   public $first_name            = 'John';          /* Users first name */
   public $last_name             = 'Doe';           /* Users last name */
   public $full_name             = '';              /* First then last name with space */
   public $hash                  = '';              /* Hash of password */
   
	/* This function provides a complete tab delimeted dump of the contents/values of an object */
	public function contents() {
		$vals = array_values(get_object_vars($this));
		return( array_reduce($vals, create_function('$a,$b','return is_null($a) ? "$b" : "$a"."\t"."$b";')));
	}
	/* Companion to contents, dumps heading/member names in tab delimeted format */
	public function headings() {
		$vals = array_keys(get_object_vars($this));
		return( array_reduce($vals, create_function('$a,$b','return is_null($a) ? "$b" : "$a"."\t"."$b";')));
	}
}

function makeNewUser($first, $last, $h) {
	$u = new User();
	$u->first_name = $first;
	$u->last_name  = $last;
	$u->full_name  = $first." ".$last;
	$u->hash = $h;
	return $u;
}

function setupDefaultUsers() {
	$users = array();
	$i = 0;
	$users[$i++] = makeNewUser('Simons', 'Cat', 'd6e93debc2f8c898125e603d57dab302');
	$users[$i++] = makeNewUser('George',  'Tirebiter', 'd9f92fc599c0caa1aae77c18729bebd3');
	$users[$i++] = makeNewUser('Chris', 'Isaak', '372a1bddc8fdca6bf09cb05e65606e19');
	writeUsers($users);
}

function writeUsers($users) {
	$fh = fopen('users.tsv', 'w+') or die("Can't open file");
	fwrite($fh, $users[0]->headings()."\n");
	for ($i = 0; $i < count($users); $i++) {
		fwrite($fh, $users[$i]->contents()."\n");
	}
	fclose($fh);
}

function readUsers() {
	if (! file_exists('users.tsv')) { setupDefaultUsers(); }
	$contents = file_get_contents('users.tsv');
	$lines    = preg_split("/\r|\n/", $contents, -1, PREG_SPLIT_NO_EMPTY);
	$keys     = preg_split("/\t/", $lines[0]);
	$i        = 0;
	for ($j = 1; $j < count($lines); $j++) {
		$vals = preg_split("/\t/", $lines[$j]);
		if (count($vals) > 1) {
			$u = new User();
			for ($k = 0; $k < count($vals); $k++) {
				$u->$keys[$k] = $vals[$k];
			}
			$users[$i] = $u;
			$i++;
		}
	}
	return $users;
}

function userHashByName($users, $full_name) {
	$res = '';
	foreach ($users as $u ) {
		if ($u->full_name == $full_name) {
			$res = $u->hash;
		}
	}
	return $res;
}

function betterWithSalt($n, $epw) {
	$salt = substr($n, 0, 3);
	return md5($salt.$epw);
}

?>